const getHeight = require("../../../../utils/getRheRemainingHeight");
const _Http = getApp().globalData.http;
const MFT = require("../../../../utils/matchingFeilType");
let dowmCount = null;
Component({
    properties: {
        padBot: {
            type: Boolean,
            value: true
        }
    },
    options: {
        addGlobalClass: true
    },
    lifetimes: {
        ready() {
            this.getList();
            getHeight.getHeight('.tabs', this).then(res => {
                this.setData({
                    listHeight: res
                })
            });
        }
    },
    data: {
        listHeight: 0, //列表高度
        tabActiveTitle: "列表", //列表类型
        show: false, //显示底部弹出
        fileSelected: {}, //选中文件详情
        content: { //请求搜索条件
            "nocache": true,
            "pageNumber": 1,
            "pageSize": 20,
            "parentid": "默认",
            "pageTotal": 1,
            "where": {
                "condition": ""
            }
        },
        list: [], //文件列表
        inTotal: 0, //总计
        sort: [], //排序规则
    },
    methods: {
        /* 是否收藏 */
        changeCollect() {
            const {
                isCollect,
                attachmentid,
                rowindex
            } = this.data.fileSelected;
            _Http.basic({
                "classname": "system.attachment.MediaCenter",
                "method": isCollect == 0 ? "collectAttachment" : "uncollectAttachment",
                "content": {
                    "collecttype": "营销物料",
                    "attachmentid": attachmentid
                }
            }).then(res => {
                if (res.msg != '成功') return wx.showToast({
                    title: res.msg,
                    icon: "none"
                })
                wx.showToast({
                    title: isCollect == 0 ? '收藏成功' : "已取消收藏",
                    icon: "none"
                })
                let list = this.data.list,
                    index = rowindex - 1;
                this.data.tabActiveTitle == '列表' ? list[index].isCollect = isCollect == 0 ? 1 : 0 : list.splice(index, 1);
                this.setData({
                    list
                })
                this.closeShow();
            })
        },
        /* 文件下载 */
        dowmLoad() {
            const that = this;
            wx.setClipboardData({
                data: this.data.fileSelected.url,
                success: function () {
                    wx.showToast({
                        title: '复制成功，将链接放置到浏览器中便可下载文件',
                        icon: "none",
                        duration: 3000
                    });
                    that.closeShow();
                }
            })
        },
        /* 获得列表 */
        getList(init = false) {
            if (init.detail != undefined) init = init.detail;
            if (init) this.setData({
                ['content.pageNumber']: 1
            })
            if (this.data.content.pageNumber > this.data.content.pageTotal) return;
            let content = this.data.content;
            if (content.parentid == '默认') content.parentid = wx.getStorageSync('siteP').salematerialfolderid;
            if (this.data.sort[0]) content.sort = this.data.sort;
            _Http.basic({
                "classname": "saletool.salematerial.salematerial",
                "method": (this.data.tabActiveTitle == '列表') ? "selectList" : "selectMyList",
                content
            }).then(res => {
                this.selectComponent('#ListBox').RefreshToComplete();
                if (res.msg != '成功') return wx.showToast({
                    title: res.msg,
                    icon: "none"
                })
                this.setData({
                    list: (res.pageNumber == 1) ? MFT.fileList(res.data) : this.data.list.concat(MFT.fileList(res.data)),
                    ['content.pageNumber']: res.pageNumber + 1,
                    ['content.pageTotal']: res.pageTotal,
                    inTotal: res.total,
                    sort: res.sort
                })
            })
        },
        /* 搜索框输入 */
        searchInput({
            detail
        }) {
            clearTimeout(dowmCount);
            this.setData({
                ['content.where.condition']: detail.trim()
            })
            dowmCount = setTimeout(() => {
                this.getList(true)
            }, 1000);

        },
        /* 清除搜索输入 */
        searchClear() {
            this.setData({
                ['content.where.condition']: ""
            })
        },
        /* tab切换 */
        tabsChange({
            detail
        }) {
            this.setData({
                tabActiveTitle: detail.title
            })
            this.getList(true);
        },
        /* 开关切换 */
        changeSwitch({
            detail
        }) {
            this.setData({
                sort: detail
            })
            this.getList(true);
        },
        /* 修改ID */
        changeParentid(id) {
            this.setData({
                ['content.parentid']: id
            })
        },
        /* 修改选中ID */
        changeId({
            detail
        }) {
            this.setData({
                fileSelected: detail,
                show: true
            })
        },
        /* 关闭修改 */
        closeShow() {
            this.setData({
                show: false
            })
            setTimeout(() => {
                this.setData({
                    fileSelected: {}
                })
            }, 150)
        },
    }
})